// () 2004  
//      .

using System;

public class TSA5059
{
    public bool MA0, MA1;
    public bool N0, N1, N2, N3, N4, N5, N6, N7, N8, N9, N10, N11, N12, N13, N14, N15, N16;
    public bool PE;
    public bool P0, P1, P2, P3;
    public bool R0, R1, R2, R3;
    public bool C0, C1;
    public bool XCE;
    public bool XCS;

    public bool POR;
    public bool FL;
    public bool I0, I1, I2;
    public bool A0, A1, A2;

    public byte[] Data()
    {
        byte[] Data = new byte [5];
    
        Bit(ref Data[0], 7, true);
        Bit(ref Data[0], 6, true);
        Bit(ref Data[0], 5, false);
        Bit(ref Data[0], 4, false);
        Bit(ref Data[0], 3, false);
        Bit(ref Data[0], 2, MA1);
        Bit(ref Data[0], 1, MA0);
        Bit(ref Data[0], 0, false);

        Bit(ref Data[1], 7, false);
        Bit(ref Data[1], 6, N14);
        Bit(ref Data[1], 5, N13);
        Bit(ref Data[1], 4, N12);
        Bit(ref Data[1], 3, N11);
        Bit(ref Data[1], 2, N10);
        Bit(ref Data[1], 1, N9);
        Bit(ref Data[1], 0, N8);

        Bit(ref Data[2], 7, N7);
        Bit(ref Data[2], 6, N6);
        Bit(ref Data[2], 5, N5);
        Bit(ref Data[2], 4, N4);
        Bit(ref Data[2], 3, N3);
        Bit(ref Data[2], 2, N2);
        Bit(ref Data[2], 1, N1);
        Bit(ref Data[2], 0, N0);

        Bit(ref Data[3], 7, true);
        Bit(ref Data[3], 6, N16);
        Bit(ref Data[3], 5, N15);
        Bit(ref Data[3], 4, PE);
        Bit(ref Data[3], 3, R3);
        Bit(ref Data[3], 2, R2);
        Bit(ref Data[3], 1, R1);
        Bit(ref Data[3], 0, R0);

        Bit(ref Data[4], 7, C1);
        Bit(ref Data[4], 6, C0);
        Bit(ref Data[4], 5, XCE);
        Bit(ref Data[4], 4, XCS);
        Bit(ref Data[4], 3, P3);
        Bit(ref Data[4], 2, P2);
        Bit(ref Data[4], 1, P1);
        Bit(ref Data[4], 0, P0);

        return Data;
    }

    public void Data(byte[] Bytes)
    {
        throw new System.NotImplementedException();
    }

    private static void Bit(ref byte Target, byte Number, bool Value)
    {
        byte Mask = (byte)(1 << Number);
        if (Value)
            Target |= Mask;
        else
            Target &= (byte)~Mask;
    }

    private static void Bit(ref ulong Target, byte Number, bool Value)
    {
        ulong Mask = (ulong)(1 << Number);
        if (Value)
            Target |= Mask;
        else
            Target &= (ulong)~Mask;
    }

    private static bool Bit(ulong Value, byte Number)
    {
        return ((Value >> Number) & 1) == 1;
    }

    public ushort ReferenceDividerRatio
    {
        get
        {
            throw new System.NotImplementedException();
        }
        set
        {
            switch (value)
            {
                case 2:
                    R3 = R2 = R1 = R0 = false;
                    break;
                case 4:
                    R3 = R2 = R1 = false;
                    R0 = true;
                    break;
                case 8:
                    R3 = R2 = R0 = false;
                    R1 = true;
                    break;
                case 16:
                    R3 = R2 = false;
                    R1 = R0 = true;
                    break;
                case 32:
                    R3 = R1 = R0 = false;
                    R2 = true;
                    break;
                case 64:
                    R3 = R1 = false;
                    R2 = R0 = true;
                    break;
                case 128:
                    R3 = R0 = false;
                    R2 = R1 = true;
                    break;
                case 256:
                    R3 = false;
                    R2 = R1 = R0 = true;
                    break;
                case 24:
                    R3 = true;
                    R2 = R1 = R0 = false;
                    break;
                case 5:
                    R3 = R0 = true;
                    R2 = R1 = false;
                    break;
                case 10:
                    R3 = R1 = true;
                    R2 = R0 = false;
                    break;
                case 20:
                    R3 = R1 = R0 = true;
                    R2 = false;
                    break;
                case 40:
                    R3 = R2 = true;
                    R1 = R0 = false;
                    break;
                case 80:
                    R3 = R2 = R0 = true;
                    R1 = false;
                    break;
                case 160:
                    R3 = R2 = R1 = true;
                    R0 = false;
                    break;
                case 320:
                    R3 = R2 = R1 = R0 = true;
                    break;
                default:
                    throw new System.ArgumentException();
            }
        }
    }

    public ulong MainDividerRatio
    {
        get
        {
            ulong N = 0;
            Bit(ref N, 17, PE);
            Bit(ref N, 16, N16);
            Bit(ref N, 15, N15);
            Bit(ref N, 14, N14);
            Bit(ref N, 13, N13);
            Bit(ref N, 12, N12);
            Bit(ref N, 11, N11);
            Bit(ref N, 10, N10);
            Bit(ref N, 9, N9);
            Bit(ref N, 8, N8);
            Bit(ref N, 7, N7);
            Bit(ref N, 6, N6);
            Bit(ref N, 5, N5);
            Bit(ref N, 4, N4);
            Bit(ref N, 3, N3);
            Bit(ref N, 2, N2);
            Bit(ref N, 1, N1);
            Bit(ref N, 0, N0);
            return N;
        }
        set
        {
            PE = Bit(value, 17);
            N16 = Bit(value, 16);
            N15 = Bit(value, 15);
            N14 = Bit(value, 14);
            N13 = Bit(value, 13);
            N12 = Bit(value, 12);
            N11 = Bit(value, 11);
            N10 = Bit(value, 10);
            N9 = Bit(value, 9);
            N8 = Bit(value, 8);
            N7 = Bit(value, 7);
            N6 = Bit(value, 6);
            N5 = Bit(value, 5);
            N4 = Bit(value, 4);
            N3 = Bit(value, 3);
            N2 = Bit(value, 2);
            N1 = Bit(value, 1);
            N0 = Bit(value, 0);
        }
    }
}
